const http = require('http');
const url = 'http://localhost:3000';

const generate = () => {
  return new Promise((resolve, reject) => {
    http.get(`${url}/client?clientId=${process.env.MICROGEN_CLIENT_ID}&clientSecret=${process.env.MICROGEN_CLIENT_SECRET}`, (resp) => {
      let data = '';

      // A chunk of data has been recieved.
      resp.on('data', (chunk) => {
        data += chunk;
      });

      // The whole response has been received. Print out the result.
      resp.on('end', () => {
        const response = JSON.parse(data);
        if(response.status == 'success') {
          resolve("success");
        } else {
          resolve("failed");
        }
      });

    }).on("error", (err) => {
      resolve("failed")
    });
  })
}

const client = (clientId) => {
  return new Promise((resolve, reject) => {
    http.get(`${url}/client/${clientId}`, (resp) => {
      let data = '';

      // A chunk of data has been recieved.
      resp.on('data', (chunk) => {
        data += chunk;
      });

      // The whole response has been received. Print out the result.
      resp.on('end', () => {
        const response = JSON.parse(data);
        if(response.status == 'success') {
          resolve(data);
        } else {
          reject("failed");
        }
      });

    }).on("error", (err) => {
      reject("failed")
    });
  })
}

const middleware = ({ app, clientId }) => (req, res, next) => {
  if(!app.get("microgen") && clientId) {
    client(clientId)
    .then(res => {
      console.log(res)
      console.log(req.hostname)
    })
    .catch(err => {
      console.log(err);
    })
  } else {
    next();
  }
}

module.exports = {
  generate,
  middleware
}

